/*
 * Alternative.java
 *
 * Created on 13 de abril de 2006, 13:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

/**
 * This class represent one of the alternatives of a desicion node
 * @author Rincew
 */
public class Alternative 
    implements IControlFlow, Cloneable, java.io.Serializable
{
    
    //--- Attributes -------------
    protected String condition;
    protected String next;
    
    /** Creates a new instance of Alternative */
    public Alternative () {
    }

    public String getCondition () {
        return condition;
    }

    public void setCondition (String condition) {
        this.condition = condition;
    }

    public String getNext () {
        return next;
    }

    public void setNext (Activity next) {
        this.next = next.getId ();
    }

    public void setNext (String next) {
        this.next = next;
    }

        /**
     * Checks if is next
     **/
    public boolean isNext(Activity node) {
        String id = node.getId ().trim ().toLowerCase ();
        String next = this.next.trim ().toLowerCase ();
        
        return (id.compareTo (next) == 0);
    }

    
    /** For testing purpouse **/
    public String toString() {
        String s = "If ("+condition + "): "; 
        if (next == null)
            s += "Not Setted.";
        else
            s += next;
        return s;
    }
    
    //--- Cloenable interface ------------------------
    
    public Object clone() {
        try {
            return super.clone ();
        } catch (CloneNotSupportedException ex) {
            ex.printStackTrace();
        }
        return null;
    }

    
    public boolean equals(Object o) {
        Alternative a = (Alternative) o;
        try {
            return (this.toString ().compareTo (a.toString ()) == 0);
        } catch(ClassCastException e) {
            e.printStackTrace();
        }
        return false;
    }
    
}
