/*
 * Transition.java
 *
 * Created on 6 de mayo de 2006, 21:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.activitymodel;

/**
 *
 * @author Rincew
 */
public class Transition {
    
    
    //--- Attributes -----------------------------------------------------
    String idOrg;
    String idDes;
    
    /** Creates a new instance of Transition */
    public Transition (String org, String des) {
        this.idOrg = org;
        this.idDes = des;
    }
    
    
    //--- Getter methods -------------------------------------------------
    public String getOrg() {        return this.idOrg;    }
    public String getDes() {        return this.idDes;    }

    
    /** Avoid traverse repeated transitions */
    public boolean equals(Object o) {
        Transition t = (Transition) o;
        return (t.toString ().compareTo (this.toString ()) == 0);
    }
    
    
    /** Returns true if the trasition starts in the activity 
     * indicated
     **/
    public boolean startIn(Activity a) {
        return ( this.idOrg.compareTo (a.getId ()) == 0  );
    }

    /** Returns true if the trasition ends in the activity 
     * indicated
     **/
    public boolean endIn(Activity a) {
        return ( this.idDes.compareTo (a.getId ()) == 0  );
    }

    
    /** Calculates and Id joining the origen and destination
     * An Id is needef for XMI translation */
    public String getId() {
        return this.idOrg + "_" + this.idDes;
    }
    
    
    /** Testing **/
    public String toString() {
     String s;
     s = this.idOrg + " --> " + this.idDes;
     return s;
    }
    
    
    
    
    
}
