/*
 * LoadUseCaseCommand.java
 *
 * Created on 29 de abril de 2006, 12:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.gui.commands;

import objectgen.usecase.*;
import java.io.File;

/**
 *
 * @author Rincew
 */
public class LoadUseCaseCommand {
    
    /** Creates a new instance of LoadUseCaseCommand */
    public LoadUseCaseCommand () {
    }

    /** Loads the XML Use Case to show its description */
    public String run(String file) {

        File f = new File(file);
        
        if (f.exists () == false) {
            return "File '" + file + "' does not exist.";
        }
        
        UseCaseXML uc = new UseCaseXML();
        try {
            uc.load (f);
        } catch (UseCaseXMLException ex) {
            return ex.toString ();
        }

        return uc.getUCDescription ();
    }
}
