package valuegen.data;

import java.util.List;

/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:52
 */
public class NoValueConstraint {

	public Variable varOrg;
        public VariableList noValueVar;
	

	public NoValueConstraint(Variable varOrg){
            this.varOrg = varOrg;
            this.noValueVar = new VariableList();
	}


	/**
	 * @param v
	 */
	public void setVariableWithoutValue(Variable v){
            this.noValueVar.add (v);
	}

	public String getVariableName(){
		return varOrg.getName ();
	}

        /** Todo */
	public String getPartitionName(){
		return varOrg.getIdOfFirstPartition ();
	}

	public List getVariableWithoutValueList(){
		return this.noValueVar.getView ();
	}

        
        /** 
         * Incomplete
         **/
        public boolean equals(Object o) {
            NoValueConstraint c = (NoValueConstraint) o;
            
            
            /*if (super.equals (c) == false )
                return false;*/
            
            //System.out.println("Equals 111...");
            if (this.varOrg.getName ().compareTo (c.varOrg.getName ()) != 0)
                return false;
            
            //System.out.println("Equals 222...");
            if (this.noValueVar.size () != c.noValueVar.size ())
                return false;
            
            
            return true;
        }
        
}