package valuegen.operations;

import valuegen.data.Variable;
import valuegen.data.Partition;
import valuegen.data.VariableList;

import objectgen.activitymodel.ActivityDiagram;
import objectgen.activitymodel.Activity;
import objectgen.activitymodel.Decision;
import objectgen.activitymodel.Alternative;

import java.util.List;
import java.util.Iterator;

/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:53
 */
public class VariableBuilder {

	public VariableBuilder(){

	}

	/**
	 * 
	 * @param ad
	 */
	public List generate(ActivityDiagram ad){
            return this.generateVarList(ad.iteratorActivities ());
        }
            
        
        protected VariableList generateVarList(Iterator itActivities) {
            VariableList vl;
            Iterator itAlternatives;
            Activity a;
            Decision d;
            Alternative al;
            Variable v;
            Partition p;
            int pc;
            
            vl = new VariableList();
            
            while (itActivities.hasNext ()) {
                a = (Activity) itActivities.next ();
                if (a.isDesicion ()) {
                    v = new Variable(a.getId ());
                    d = (Decision) a;
                    pc = 0;
                    itAlternatives = d.iterator ();
                    while(itAlternatives.hasNext ()) {
                        al = (Alternative) itAlternatives.next ();
                        p = new Partition("P_" + (++pc), al.getCondition ());
                        v.addPartition (p);
                    }
                    vl.add (v);
                } // If
            } // While
            
            return vl;
	}
        
        

}