/*
 * AllActivitiesCriterium.java
 *
 * Created on 3 de noviembre de 2006, 9:48
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import java.util.Iterator;
import java.util.ArrayList;
import java.util.LinkedList;
import objectgen.activitymodel.Activity;
import objectgen.activitymodel.Transition;
import objectgen.activitymodel.ActivityDiagram;

/**
 *
 * @author Rincew
 */
public class AllTransitionsCriterium 
    extends AllScenariosCriterium
{
    
    /** Creates a new instance of AllActivitiesCriterium */
    public AllTransitionsCriterium () {
        super();
    }


    /** 
     * This method filtrate the test objectives obtained
     * to generate the minimun step that covers all
     * transitions
     **/
    
    public TestObjectiveList generate(ActivityDiagram ad) {
        TestObjectiveList tol_final;
        TestObjective to;
        TestObjective to_tmp;
        Transition trans;
        LinkedList tol_tmp;
        Iterator to_it;
        Iterator tran_it;
        int numOfObjectives;
        int index;
        boolean add;
        
        super.generate(ad);
        
        tol_final = new TestObjectiveList();
        tol_tmp = new LinkedList();
        to_it = this.objectives.iterator ();
        while (to_it.hasNext ())
            tol_tmp.add (to_it.next ());

        numOfObjectives = tol_tmp.size ();
        
        for (index = 0; index < numOfObjectives; index++) {
            to = this.extractBigger (tol_tmp);
            if (tol_final.size () == 0) {
                log.debug("First and bigger test objective added: " + to);
                tol_final.add (to);
                continue;
            }
            

            tran_it = to.transitionsIterator ();
            while(tran_it.hasNext ()) {
                trans = (Transition) tran_it.next ();
                to_it = tol_final.iterator ();
                add = true;
                while (to_it.hasNext ()) {
                    to_tmp = (TestObjective) to_it.next ();
                    if (to_tmp.contains (trans)) {
                        add = false;
                        break;
                    }
                }
                
                if (add == true) {
                    log.debug ("Adding a new test objective.");
                    tol_final.add (to);
                    // Salimos del while que recorre las transiciones
                    break;
                }
            }
            
            
            //--- Deprecated 
            /*
            to_it = tol_final.iterator ();
            while (to_it.hasNext ()) {
                to_tmp = (TestObjective) to_it.next ();
                tran_it = to_tmp.transitionsIterator ();
                add = false;
                while (tran_it.hasNext ()) {
                    trans = (Transition)tran_it.next ();
                    if (to.contains (trans) == false) {
                        add = true;
                        break;
                    }
                    
                } // While transitions
                
            }*/
            
        } // for
        
        System.out.println("Initial test objectives: " + this.objectives.size () );
        System.out.println("Final test objectives: " + tol_final.size () );

        return tol_final;
            
    }
    
    
    /**
     * Helper method. Returns and remove the biggest test objective 
     * in the list
     * Warning, tol is an in/out parameter. It is modified inside
     *this method.
     **/
    private TestObjective extractBigger(LinkedList tol) {
        TestObjective to = null;
        TestObjective to_tmp;
        Iterator it;
        
        it = tol.iterator ();
        while (it.hasNext ()) {
            to_tmp = (TestObjective) it.next ();
            if (to == null)
                to = to_tmp;
            else {
                if (to.activities.size () < to_tmp.activities.size ())
                    to = to_tmp;
            }
        }
        
        
        if (to == null) {
            log.warn ("No test objective to extract and delete");
        } else {
            tol.remove (to);
        }
        
        return to;
    }
    
}
