/*
 * TestObjectiveList.java
 *
 * Created on 23 de abril de 2006, 11:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.testobjective;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author Rincew
 */
public class TestObjectiveList 
    implements java.io.Serializable
{
    
    
    private ArrayList to;
    
    /** 
     * This atrribute indicates if no new test objectives are
     * added into the list
     **/
    private boolean frozen;
    
    /** Creates a new instance of TestObjectiveList */
    public TestObjectiveList () {
        to = new ArrayList();
        this.frozen = false;
    }
    
    /** **/
    public void add(TestObjective o) {
        if (!(this.frozen))
            this.to.add (o);
    }
    
    /** **/
    public Iterator iterator() {
        return this.to.iterator ();
    }
    
    /** @return number of elements **/
    public int size() {
        return this.to.size ();
    }
    
    /**
     * Set frozen attributes.
     * When setted, no more objectives are added into the list
     **/
    public void setFrozen() {
        this.frozen = true;
    }
    
    /**
     * Return the state of frozen attribute
     **/
    public boolean isFrozen() {
        return this.frozen;
    }
    
    /** **/
    public String toString() {
        StringBuffer sb = new StringBuffer("");
        int c;
        
        
        sb.append("Test objectives: " + this.to.size () + "\n");
        sb.append("=======================\n");
        for ( c = 0; c < this.to.size (); c++ ) {
            sb.append ((c+1) + "::: " + this.to.get (c) + "\n");
        }
        
        return sb.toString ();
    }
    
}
