/*
 * IValidate.java
 *
 * Created on 12 de noviembre de 2006, 18:33
 *
 */

package objectgen.usecase.pattern;

/**
 * This interfaz, and its implementing class, are not used 
 * in ObjectGen tool, but it is porporcionated to use ObjectGen 
 * for verify that a step match any pattern. This one allows to 
 *  use ObjectGen as validator into a requirement tool
  */
public interface IValidate {
    
    /** This method returns true is step match with any pattern
     *  for steps in the main sequence.
     * */
    public boolean validateMainStep(String step);

    /** This method returns true is step match with any pattern
     *  for steps in the alternative / erroneous sequences.
     **/
    public boolean validateAlternativeStep(String step);
}
