/*
 * ValidateStep.java
 *
 * Created on 12 de noviembre de 2006, 18:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package objectgen.usecase.pattern;

import java.io.File;

/**
 *
 * @author Rincew
 */
public class ValidateStep 
    implements IValidate
{
    
    private StringBuffer innerLog;
    private IPatternMatcher pm;
    
    /** Creates a new instance of ValidateStep */
    public ValidateStep () {
        this.innerLog = new StringBuffer("");
        this.pm = new PatternMatcher();
    }
    
    
    /** This method returns true is step match with any pattern.
     *  This method it is nout used in ObjectGen tool, but
     *  it is porporcionated to use ObjectGen for
     *  verify that a step match any pattern. This one allows to 
     *  use ObjectGen as validator into a requirement tool
     * */
    public boolean validateMainStep(String step) {
        boolean b = false;
        File f;
        IPatternReader pr;
        String r[];
              
        // 1. Validate pattern for actor
        pr = PatternReaderFactory.Get("ActorPatternFile");
        r = pm.match (step,pr );
        if (r == null) {
            b = false;
        }
        if (r.length == 0)
            b = false;
        
        if (b == false) {
            innerLog.append ("Step >>" + step + "<< does not match the actors patterns.");
        }
        
        return b;
    }

    /** **/
    public boolean validateAlternativeStep(String step) {
        boolean b = false;
        
        // 1. Validate pattern 
        
        
        return b;
    }
    
    /** If step does not match, log contains a descriptive error message **/
    public String getLog() {
        return this.innerLog.toString ();
    }
}
