/*
 * DataSpace.java
 *
 * Created on 15 de octubre de 2006, 11:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package testgen.gui.dataspace;

import java.util.Hashtable;

/**
 * This is a singleton class to store values and objects needed 
 * for executing a sequence of operations, like generate behaviour
 * diagram and, then, generate test objectives.
 * 
 * @author Rincew
 */
public class DataSpace {
    
    private static DataSpace instance = null;
    private Hashtable dataSpace;
    
    /**
     * Creates a new instance of DataSpace
     */
    private DataSpace () {
        this.dataSpace = new Hashtable();
    }
    
    /** **/
    public static DataSpace getInstance() {
        if (DataSpace.instance == null)
            DataSpace.instance = new DataSpace();
        
        return DataSpace.instance;
    }
    
    /** **/
    public void put(String key, Object value) {
        this.dataSpace.put (key, value);
    }
    
    /** **/
    public Object get(String key) {
        return this.dataSpace.get (key);
    }
    
        /** **/
    public Object remove(String key) {
        return this.dataSpace.remove (key);
    }

}
