/*
 * Main.java
 *
 * Created on 26 de diciembre de 2006, 14:01
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package valuegen;

import objectgen.activitymodel.*;
import objectgen.testobjective.*;
import valuegen.data.*;
import valuegen.operations.*;

import java.io.*;
import java.util.List;

import org.apache.log4j.PropertyConfigurator;
import org.apache.log4j.BasicConfigurator;

/**
 *
 * @author Rincew
 */
public class Main {
    
    public static void main (String[] args) 
        throws Exception
    {
        VariableList vl;
        VariableBuilder vb;
        VariableOutputXML vo;
        ConstraintBuilder cb;
        ActivityDiagram ad;
        List cl;
        GenerateBSScript gbss;

        // Logs & config.
        BasicConfigurator.configure ();
        PropertyConfigurator.configure(/*path+*/"./config/logs.prop");
        objectgen.configuration.Configuration.Create ();

        File f = new File("variables.xml");
        
        /** Tenemos que recuperar un diagrama de actividades **/
        FileInputStream fis = new FileInputStream("C:/Code/TestApps/ObjectGen/sample_files/ActivityDiagram.bin");
        ObjectInputStream ois = new ObjectInputStream(fis);
        ad = (ActivityDiagram)ois.readObject ();
        
        vb = new VariableBuilder();
        vl = (VariableList) vb.generate (ad);
        
        System.out.println ("Variables: " + vl.size ());
        vo = new VariableOutputXML();
        vo.generate (f, vl);
        
        // Esto no tendra que hacerlo yo
        ITestObjectiveCriterion tog = objectgen.testobjective.CoverageCriteriaFactory.Get ();
        System.out.println ("Criterion: " + objectgen.testobjective.CoverageCriteriaFactory.GetName ());
        TestObjectiveList tol = tog.generate (ad);
        System.out.println ("Test objectives: " + tol.size ());
        
        cb = new ConstraintBuilder();
        cl = cb.generate (vl, tol);
        
        System.out.println ("Constrains: " + cl.size ());
        
        File output = new File("r.bsh");
        gbss = new GenerateBSScript();
        gbss.generate (cl, vl, output);
        
        
        System.out.println("Ok.");
    }
    
}
