package valuegen.data;


import java.util.Iterator;
import java.util.List;

import org.apache.log4j.Logger;

/**
 * @version 1.0
 * @created 26-Dec-2006 13:58:53
 */
public class VariableList extends TemplateArrayList
{

	public VariableList(){
            super();
	}

	/**
     * Returns a new variable list containing the variables of the object not
     * contained in the parameter l.
     * 
     * 
     * @param l
     */
	public VariableList intersection(VariableList vl){
		return null;
	}

	/**
	 * Returns the variable associated to a decision node.
	 * 
	 * @param id
	 */
	public Variable getVariableForNode(String id){
            Variable tmp;
            Iterator it;
            
            it = l.iterator ();
            while (it.hasNext ()) {
                tmp = (Variable) it.next ();
                if (tmp.getActivityId ().compareTo (id) == 0)
                    return tmp;
            }
            
            log.fatal("No variable found for activity: " + id);
            return null;
	}
        
    
    /** **/
    public Variable getVariableWithName(String name) {
        
        Iterator it;
        Variable v;
        
        it = this.iterator ();
        while (it.hasNext ()) {
            v = (Variable) it.next ();
            if (name.compareTo (v.getName ()) == 0)
                return v;
        }
        
        log.error ("No variable found with name: " + name);
        return null;
    }        

     //--- Log ------------------------------------------------------------
    static Logger log;
    static {
        log = Logger.getLogger (VariableList.class.getName());
    }

}